from typing import Optional

from cpl_core.console import Console
from cpl_query.extension import List

from py_to_uxf_core.abc.implementation_scanner_abc import ImplementationScannerABC
from py_to_uxf_core.model.class_implementation import ClassImplementation
from py_to_uxf_core.model.python_class import PythonClass


class ImplementationScannerService(ImplementationScannerABC):

    def __init__(self):
        pass

    def scan_line_for_implementation(self, line: str, classes: List[PythonClass]) -> Optional[ClassImplementation]:
        line = line.replace('    ', '')
        line = line.replace('\t', '')
        if line.startswith('class ') and '(' in line and ')' in line:
            sub_name = line.split('class ')[1].split('(')[0]
            sub: Optional[PythonClass] = classes.where(lambda c: c.name == sub_name).first_or_default()
            if sub is None:
                return None

            base_name = line.split('(')[1].split(')')[0]
            base: Optional[PythonClass] = classes.where(lambda c: c.name == base_name).first_or_default()
            if base is None:
                return None

            return ClassImplementation(base, sub)

        return None
